#include "gtest/gtest.h"
#include "EcoSim.h"
#include <iostream>
#include <string>
#include <vector>
using namespace std;

class Testing : public ::testing::Test {

protected:
    Testing() {}
    virtual ~Testing() {
    }

    virtual void SetUp() {}
    
    virtual void TearDown() {
	cout << endl << ":::END" << endl;
    }
};
    

TEST_F(Testing, increment) {
    cout << ":::NAME test increment" << endl;
    cout << ":::MAX_SCORE 5" << endl;
    cout << ":::SCORE 5" << endl;
    cout << ":::VISIBILITY visible" << endl;
    int count = 1;
    incrementCounter(&count);
    EXPECT_EQ(2, count) << ":::SCORE 0";
//    cout << ":::END" << endl;
}

TEST_F(Testing, populationUpdate) {
    cout << ":::NAME population update" << endl;
    cout << ":::MAX_SCORE 10" << endl;
    cout << ":::SCORE 10" << endl;
    cout << ":::VISIBILITY visible" << endl;
    double numF = 100.0, numR = 100.0;
//    std::cout << "Look for stray output" << std::endl;
    updatePopulations(0.1, 0.001, 0.1, 0.1, 1000.0, numR, numF);

    EXPECT_DOUBLE_EQ(99.0, numR) << ":::SCORE 0";
    EXPECT_DOUBLE_EQ(91.0, numF) << ":::SCORE 0";
//    cout << ":::END" << endl;
}

TEST_F(Testing, plotPopulationsSame) {
    cout << ":::NAME plot populations same values" << endl;
    cout << ":::MAX_SCORE 9" << endl;
    cout << ":::SCORE 9" << endl;
    cout << ":::VISIBILITY visible" << endl;

    std::stringstream buffer;
    std::streambuf * old = std::cout.rdbuf(buffer.rdbuf());
    
    double numF = 10.0, numR = 10.1;
    plotPopulations(numR, numF, 0.5);
    std::string text = buffer.str(); 
    
    std::cout.rdbuf( old );
    cout << "Made text: " << text << endl;
    
    EXPECT_EQ("     *", text) << ":::SCORE 0";
//    cout << ":::END" << endl;
}

TEST_F(Testing, plotPopulationsSmallerRabbit) {
    cout << ":::NAME plot populations smaller rabbit" << endl;
    cout << ":::MAX_SCORE 8" << endl;
    cout << ":::SCORE 8" << endl;
    cout << ":::VISIBILITY visible" << endl;

    std::stringstream buffer;
    std::streambuf * old = std::cout.rdbuf(buffer.rdbuf());
    
    double numF = 20.1, numR = 10.1;
    plotPopulations(numR, numF, 0.2);
    std::string text = buffer.str(); 
    
    std::cout.rdbuf( old );
    cout << "Made text: " << text << endl;
    
    EXPECT_EQ("  r F", text) << ":::SCORE 0";
//    cout << ":::END" << endl;
}

TEST_F(Testing, plotPopulationsSmallerFox) {
    cout << ":::NAME plot populations smaller fox" << endl;
    cout << ":::MAX_SCORE 8" << endl;
    cout << ":::SCORE 8" << endl;
    cout << ":::VISIBILITY visible" << endl;

    std::stringstream buffer;
    std::streambuf * old = std::cout.rdbuf(buffer.rdbuf());
    
    double numF = 10.0, numR = 50.0;
    plotPopulations(numR, numF, 0.1);
    std::string text = buffer.str(); 
    
    std::cout.rdbuf( old );
    cout << "Made text: " << text << endl;
    
    EXPECT_EQ(" F   r", text) << ":::SCORE 0";
//    cout << ":::END" << endl;
}

TEST_F(Testing, plotCharacter) {
    cout << ":::NAME plotCharacter" << endl;
    cout << ":::MAX_SCORE 5" << endl;
    cout << ":::SCORE 5" << endl;
    cout << ":::VISIBILITY visible" << endl;

    std::stringstream buffer;
    std::streambuf * old = std::cout.rdbuf(buffer.rdbuf());
    
    plotCharacter(2, 'T');
    std::string text = buffer.str(); 
    
    std::cout.rdbuf( old );
    cout << "Made text: " << text << endl;
    
    EXPECT_EQ("  T", text) << ":::SCORE 0";
//    cout << ":::END" << endl;
}
